Index: uspace/lib/label/test/label.c
===================================================================
--- uspace/lib/label/test/label.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
+++ uspace/lib/label/test/label.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -0,0 +1,613 @@
+/*
+ * Copyright (c) 2017 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#include <label/label.h>
+#include <mem.h>
+#include <pcut/pcut.h>
+#include <stddef.h>
+#include <stdlib.h>
+
+PCUT_INIT
+
+PCUT_TEST_SUITE(label);
+
+static int label_test_get_bsize(void *, size_t *);
+static int label_test_get_nblocks(void *, aoff64_t *);
+static int label_test_read(void *, aoff64_t, size_t, void *);
+static int label_test_write(void *, aoff64_t, size_t, const void *);
+
+label_bd_ops_t label_test_ops = {
+	.get_bsize = label_test_get_bsize,
+	.get_nblocks = label_test_get_nblocks,
+	.read = label_test_read,
+	.write = label_test_write
+};
+
+/** Pretended block device for testing */
+typedef struct {
+	char *data;
+	size_t bsize;
+	aoff64_t nblocks;
+} test_bd_t;
+
+enum {
+	test_block_size = 512,
+	test_nblocks = 1024
+};
+
+/** Create pretended block device.
+ *
+ * @param bsize Block size
+ * @param nblocks Number of blocks
+ * @param rbd Place to store pointer to new pretended block device
+ */
+static int test_bd_create(size_t bsize, aoff64_t nblocks, test_bd_t **rbd)
+{
+	test_bd_t *bd;
+
+	bd = calloc(1, sizeof(test_bd_t));
+	if (bd == NULL)
+		return ENOMEM;
+
+	bd->data = calloc(bsize, nblocks);
+	if (bd->data == NULL) {
+		free(bd);
+		return ENOMEM;
+	}
+
+	bd->bsize = bsize;
+	bd->nblocks = nblocks;
+	*rbd = bd;
+
+	return EOK;
+}
+
+/** Destroy pretended block device.
+ *
+ * @param bd Pretended block device
+ */
+static void test_bd_destroy(test_bd_t *bd)
+{
+	free(bd->data);
+	free(bd);
+}
+
+/** Get block size wrapper for liblabel */
+static int label_test_get_bsize(void *arg, size_t *bsize)
+{
+	test_bd_t *bd = (test_bd_t *)arg;
+
+	*bsize = bd->bsize;
+	return EOK;
+}
+
+/** Get number of blocks wrapper for liblabel */
+static int label_test_get_nblocks(void *arg, aoff64_t *nblocks)
+{
+	test_bd_t *bd = (test_bd_t *)arg;
+
+	*nblocks = bd->nblocks;
+	return EOK;
+}
+
+/** Read blocks wrapper for liblabel */
+static int label_test_read(void *arg, aoff64_t ba, size_t cnt, void *buf)
+{
+	test_bd_t *bd = (test_bd_t *)arg;
+
+	if (ba >= bd->nblocks)
+		return EINVAL;
+
+	memcpy(buf, bd->data + ba * bd->bsize, bd->bsize);
+	return EOK;
+}
+
+/** Write blocks wrapper for liblabel */
+static int label_test_write(void *arg, aoff64_t ba, size_t cnt, const void *data)
+{
+	test_bd_t *bd = (test_bd_t *)arg;
+
+	if (ba >= bd->nblocks)
+		return EINVAL;
+
+	memcpy(bd->data + ba * bd->bsize, data, bd->bsize);
+	return EOK;
+}
+
+PCUT_TEST(open_empty) {
+	label_t *label;
+	label_bd_t lbd;
+	label_info_t linfo;
+	label_part_t *part;
+	test_bd_t *bd = NULL;
+	int rc;
+
+	rc = test_bd_create(test_block_size, test_nblocks, &bd);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	lbd.ops = &label_test_ops;
+	lbd.arg = (void *)bd;
+
+	rc = label_open(&lbd, &label);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = label_get_info(label, &linfo);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	PCUT_ASSERT_INT_EQUALS(lt_none, linfo.ltype);
+	PCUT_ASSERT_INT_EQUALS(0, linfo.flags);
+
+	/* There should be exactly one pseudo partition */
+	part = label_part_first(label);
+	PCUT_ASSERT_NOT_NULL(part);
+
+	part = label_part_next(part);
+	PCUT_ASSERT_NULL(part);
+
+	label_close(label);
+
+	test_bd_destroy(bd);
+}
+
+PCUT_TEST(create_destroy_mbr) {
+	label_t *label;
+	label_bd_t lbd;
+	label_info_t linfo;
+	label_part_t *part;
+	test_bd_t *bd = NULL;
+	int rc;
+
+	rc = test_bd_create(test_block_size, test_nblocks, &bd);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	lbd.ops = &label_test_ops;
+	lbd.arg = (void *)bd;
+
+	rc = label_create(&lbd, lt_mbr, &label);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = label_get_info(label, &linfo);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	PCUT_ASSERT_INT_EQUALS(lt_mbr, linfo.ltype);
+	PCUT_ASSERT_INT_EQUALS(lf_ext_supp | lf_can_create_pri |
+	    lf_can_create_ext, linfo.flags);
+
+	/* There should be no partitions */
+	part = label_part_first(label);
+	PCUT_ASSERT_NULL(part);
+
+	/* Close and reopen */
+	label_close(label);
+
+	rc = label_open(&lbd, &label);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = label_get_info(label, &linfo);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	/* Everything should still be the same */
+	PCUT_ASSERT_INT_EQUALS(lt_mbr, linfo.ltype);
+	PCUT_ASSERT_INT_EQUALS(lf_ext_supp | lf_can_create_pri |
+	    lf_can_create_ext, linfo.flags);
+
+	rc = label_destroy(label);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	/* There should be no label now */
+
+	rc = label_open(&lbd, &label);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = label_get_info(label, &linfo);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	PCUT_ASSERT_INT_EQUALS(lt_none, linfo.ltype);
+	PCUT_ASSERT_INT_EQUALS(0, linfo.flags);
+
+	label_close(label);
+
+	test_bd_destroy(bd);
+}
+
+PCUT_TEST(create_destroy_gpt) {
+	label_t *label;
+	label_bd_t lbd;
+	label_info_t linfo;
+	label_part_t *part;
+	test_bd_t *bd = NULL;
+	int rc;
+
+	rc = test_bd_create(test_block_size, test_nblocks, &bd);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	lbd.ops = &label_test_ops;
+	lbd.arg = (void *)bd;
+
+	rc = label_create(&lbd, lt_gpt, &label);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = label_get_info(label, &linfo);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	PCUT_ASSERT_INT_EQUALS(lt_gpt, linfo.ltype);
+	PCUT_ASSERT_INT_EQUALS(lf_can_create_pri | lf_ptype_uuid, linfo.flags);
+
+	/* There should be no partitions */
+	part = label_part_first(label);
+	PCUT_ASSERT_NULL(part);
+
+	/* Close and reopen */
+	label_close(label);
+
+	rc = label_open(&lbd, &label);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = label_get_info(label, &linfo);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	/* Everything should still be the same */
+	PCUT_ASSERT_INT_EQUALS(lt_gpt, linfo.ltype);
+	PCUT_ASSERT_INT_EQUALS(lf_can_create_pri | lf_ptype_uuid, linfo.flags);
+
+	rc = label_destroy(label);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	/* There should be no label now */
+
+	rc = label_open(&lbd, &label);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = label_get_info(label, &linfo);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	PCUT_ASSERT_INT_EQUALS(lt_none, linfo.ltype);
+	PCUT_ASSERT_INT_EQUALS(0, linfo.flags);
+
+	label_close(label);
+
+	test_bd_destroy(bd);
+}
+
+PCUT_TEST(mbr_primary_part) {
+	label_t *label;
+	label_bd_t lbd;
+	label_info_t linfo;
+	label_part_t *part;
+	label_part_spec_t pspec;
+	label_part_info_t pinfo;
+	label_ptype_t ptype;
+	test_bd_t *bd = NULL;
+	int rc;
+
+	rc = test_bd_create(test_block_size, test_nblocks, &bd);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	lbd.ops = &label_test_ops;
+	lbd.arg = (void *)bd;
+
+	rc = label_create(&lbd, lt_mbr, &label);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = label_get_info(label, &linfo);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	/* There should be no partitions */
+	part = label_part_first(label);
+	PCUT_ASSERT_NULL(part);
+
+	rc = label_suggest_ptype(label, lpc_ext4, &ptype);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	memset(&pspec, 0, sizeof(pspec));
+	pspec.index = 1;
+	pspec.block0 = linfo.ablock0;
+	pspec.nblocks = linfo.anblocks;
+	pspec.hdr_blocks = 0;
+	pspec.pkind = lpk_primary;
+	pspec.ptype = ptype;
+
+	rc = label_part_create(label, &pspec, &part);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	label_part_get_info(part, &pinfo);
+	PCUT_ASSERT_INT_EQUALS(1, pinfo.index);
+	PCUT_ASSERT_INT_EQUALS(lpk_primary, pinfo.pkind);
+	PCUT_ASSERT_INT_EQUALS(linfo.ablock0, pinfo.block0);
+	PCUT_ASSERT_INT_EQUALS(linfo.anblocks, pinfo.nblocks);
+
+	/* Close and reopen */
+	label_close(label);
+
+	rc = label_open(&lbd, &label);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = label_get_info(label, &linfo);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	PCUT_ASSERT_INT_EQUALS(lt_mbr, linfo.ltype);
+	PCUT_ASSERT_INT_EQUALS(lf_ext_supp | lf_can_create_pri |
+	    lf_can_create_ext | lf_can_delete_part, linfo.flags);
+
+	part = label_part_first(label);
+	PCUT_ASSERT_NOT_NULL(part);
+	PCUT_ASSERT_NULL(label_part_next(part));
+
+	label_part_get_info(part, &pinfo);
+	PCUT_ASSERT_INT_EQUALS(1, pinfo.index);
+	PCUT_ASSERT_INT_EQUALS(lpk_primary, pinfo.pkind);
+	PCUT_ASSERT_INT_EQUALS(linfo.ablock0, pinfo.block0);
+	PCUT_ASSERT_INT_EQUALS(linfo.anblocks, pinfo.nblocks);
+
+	/* Destroy the partition */
+	rc = label_part_destroy(part);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	/* Close and reopen */
+	label_close(label);
+
+	rc = label_open(&lbd, &label);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	/* There should be no partitions */
+	part = label_part_first(label);
+	PCUT_ASSERT_NULL(part);
+
+	label_close(label);
+
+	test_bd_destroy(bd);
+}
+
+PCUT_TEST(mbr_logical_part) {
+	label_t *label;
+	label_bd_t lbd;
+	label_info_t linfo;
+	label_part_t *part, *lpart, *epart;
+	label_part_spec_t pspec;
+	label_ptype_t ptype;
+	label_part_info_t pinfo, lpinfo, epinfo;
+	test_bd_t *bd = NULL;
+	int rc;
+
+	rc = test_bd_create(test_block_size, test_nblocks, &bd);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	lbd.ops = &label_test_ops;
+	lbd.arg = (void *)bd;
+
+	rc = label_create(&lbd, lt_mbr, &label);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = label_get_info(label, &linfo);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	/* There should be no partitions */
+	part = label_part_first(label);
+	PCUT_ASSERT_NULL(part);
+
+	memset(&pspec, 0, sizeof(pspec));
+	pspec.index = 1;
+	pspec.block0 = linfo.ablock0;
+	pspec.nblocks = linfo.anblocks;
+	pspec.hdr_blocks = 0;
+	pspec.pkind = lpk_extended;
+
+	rc = label_part_create(label, &pspec, &epart);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	label_part_get_info(epart, &epinfo);
+	PCUT_ASSERT_INT_EQUALS(1, epinfo.index);
+	PCUT_ASSERT_INT_EQUALS(lpk_extended, epinfo.pkind);
+	PCUT_ASSERT_INT_EQUALS(linfo.ablock0, epinfo.block0);
+	PCUT_ASSERT_INT_EQUALS(linfo.anblocks, epinfo.nblocks);
+
+	/* Close and reopen */
+	label_close(label);
+
+	rc = label_open(&lbd, &label);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = label_get_info(label, &linfo);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	PCUT_ASSERT_INT_EQUALS(lt_mbr, linfo.ltype);
+	PCUT_ASSERT_INT_EQUALS(lf_ext_supp | lf_can_create_pri |
+	    lf_can_create_log | lf_can_delete_part, linfo.flags);
+
+	epart = label_part_first(label);
+	PCUT_ASSERT_NOT_NULL(epart);
+	PCUT_ASSERT_NULL(label_part_next(epart));
+
+	label_part_get_info(epart, &epinfo);
+	PCUT_ASSERT_INT_EQUALS(1, epinfo.index);
+	PCUT_ASSERT_INT_EQUALS(lpk_extended, epinfo.pkind);
+	PCUT_ASSERT_INT_EQUALS(linfo.ablock0, epinfo.block0);
+	PCUT_ASSERT_INT_EQUALS(linfo.anblocks, epinfo.nblocks);
+
+	/* Create logical partition */
+	rc = label_suggest_ptype(label, lpc_ext4, &ptype);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	memset(&pspec, 0, sizeof(pspec));
+	pspec.index = 0;
+	pspec.block0 = epinfo.block0 + 1;
+	pspec.nblocks = epinfo.nblocks - 1;
+	pspec.hdr_blocks = 1;
+	pspec.pkind = lpk_logical;
+	pspec.ptype = ptype;
+
+	rc = label_part_create(label, &pspec, &lpart);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	label_part_get_info(lpart, &lpinfo);
+	PCUT_ASSERT_INT_EQUALS(5, lpinfo.index);
+	PCUT_ASSERT_INT_EQUALS(lpk_logical, lpinfo.pkind);
+	PCUT_ASSERT_INT_EQUALS(epinfo.block0 + 1, lpinfo.block0);
+	PCUT_ASSERT_INT_EQUALS(epinfo.nblocks - 1, lpinfo.nblocks);
+
+	/* Close and reopen */
+	label_close(label);
+
+	rc = label_open(&lbd, &label);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	/* Find the extended and the logical partition */
+
+	epart = NULL;
+	lpart = NULL;
+
+	part = label_part_first(label);
+	while (part != NULL) {
+		label_part_get_info(part, &pinfo);
+		if (pinfo.pkind == lpk_extended) {
+			epart = part;
+		} else {
+			PCUT_ASSERT_INT_EQUALS(lpk_logical, pinfo.pkind);
+			lpart = part;
+		}
+
+		part = label_part_next(part);
+	}
+
+	PCUT_ASSERT_NOT_NULL(epart);
+	PCUT_ASSERT_NOT_NULL(lpart);
+
+	/* Destroy the logical partition */
+	rc = label_part_destroy(lpart);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	/* Destroy the extended partition */
+	rc = label_part_destroy(epart);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	/* Close and reopen */
+	label_close(label);
+
+	rc = label_open(&lbd, &label);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	/* There should be no partitions */
+	part = label_part_first(label);
+	PCUT_ASSERT_NULL(part);
+
+	label_close(label);
+
+	test_bd_destroy(bd);
+}
+
+
+PCUT_TEST(gpt_part) {
+	label_t *label;
+	label_bd_t lbd;
+	label_info_t linfo;
+	label_part_t *part;
+	label_part_spec_t pspec;
+	label_part_info_t pinfo;
+	label_ptype_t ptype;
+	test_bd_t *bd = NULL;
+	int rc;
+
+	rc = test_bd_create(test_block_size, test_nblocks, &bd);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	lbd.ops = &label_test_ops;
+	lbd.arg = (void *)bd;
+
+	rc = label_create(&lbd, lt_gpt, &label);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = label_get_info(label, &linfo);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	/* There should be no partitions */
+	part = label_part_first(label);
+	PCUT_ASSERT_NULL(part);
+
+	rc = label_suggest_ptype(label, lpc_ext4, &ptype);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	memset(&pspec, 0, sizeof(pspec));
+	pspec.index = 1;
+	pspec.block0 = linfo.ablock0;
+	pspec.nblocks = linfo.anblocks;
+	pspec.hdr_blocks = 0;
+	pspec.pkind = lpk_primary;
+	pspec.ptype = ptype;
+
+	rc = label_part_create(label, &pspec, &part);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	label_part_get_info(part, &pinfo);
+	PCUT_ASSERT_INT_EQUALS(1, pinfo.index);
+	PCUT_ASSERT_INT_EQUALS(lpk_primary, pinfo.pkind);
+	PCUT_ASSERT_INT_EQUALS(linfo.ablock0, pinfo.block0);
+	PCUT_ASSERT_INT_EQUALS(linfo.anblocks, pinfo.nblocks);
+
+	/* Close and reopen */
+	label_close(label);
+
+	rc = label_open(&lbd, &label);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = label_get_info(label, &linfo);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	PCUT_ASSERT_INT_EQUALS(lt_gpt, linfo.ltype);
+	PCUT_ASSERT_INT_EQUALS(lf_can_create_pri | lf_ptype_uuid |
+	    lf_can_delete_part, linfo.flags);
+
+	part = label_part_first(label);
+	PCUT_ASSERT_NOT_NULL(part);
+	PCUT_ASSERT_NULL(label_part_next(part));
+
+	label_part_get_info(part, &pinfo);
+	PCUT_ASSERT_INT_EQUALS(1, pinfo.index);
+	PCUT_ASSERT_INT_EQUALS(lpk_primary, pinfo.pkind);
+	PCUT_ASSERT_INT_EQUALS(linfo.ablock0, pinfo.block0);
+	PCUT_ASSERT_INT_EQUALS(linfo.anblocks, pinfo.nblocks);
+
+	/* Destroy the partition */
+	rc = label_part_destroy(part);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	/* Close and reopen */
+	label_close(label);
+
+	rc = label_open(&lbd, &label);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	/* There should be no partitions */
+	part = label_part_first(label);
+	PCUT_ASSERT_NULL(part);
+
+	label_close(label);
+
+	test_bd_destroy(bd);
+}
+
+PCUT_EXPORT(label);
Index: uspace/lib/label/test/main.c
===================================================================
--- uspace/lib/label/test/main.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
+++ uspace/lib/label/test/main.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -0,0 +1,35 @@
+/*
+ * Copyright (c) 2017 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#include <pcut/pcut.h>
+
+PCUT_INIT
+
+PCUT_IMPORT(label);
+
+PCUT_MAIN()
Index: uspace/lib/math/arch/amd64/src/cos.S
===================================================================
--- uspace/lib/math/arch/amd64/src/cos.S	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/math/arch/amd64/src/cos.S	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -68,5 +68,5 @@
 		jnz reduce
 	
-	fstpl %st(1)
+	fstp %st(1)
 	fcos
 	
Index: uspace/lib/math/arch/amd64/src/sin.S
===================================================================
--- uspace/lib/math/arch/amd64/src/sin.S	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/math/arch/amd64/src/sin.S	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -68,5 +68,5 @@
 		jnz reduce
 	
-	fstpl %st(1)
+	fstp %st(1)
 	fsin
 	
Index: uspace/lib/nettl/src/amap.c
===================================================================
--- uspace/lib/nettl/src/amap.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/nettl/src/amap.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -59,4 +59,20 @@
 #include <stdlib.h>
 
+/** Convert association map flags to port range flags.
+ *
+ * @param flags Association map flags
+ * @return Port range flags
+ */
+static portrng_flags_t aflags_to_pflags(amap_flags_t flags)
+{
+	portrng_flags_t pflags;
+
+	pflags = 0;
+	if ((flags & af_allow_system) != 0)
+		pflags |= pf_allow_system;
+
+	return pflags;
+}
+
 /** Create association map.
  *
@@ -97,4 +113,8 @@
 {
 	log_msg(LOG_DEFAULT, LVL_DEBUG2, "amap_destroy()");
+
+	assert(list_empty(&map->repla));
+	assert(list_empty(&map->laddr));
+	assert(list_empty(&map->llink));
 	free(map);
 }
@@ -374,5 +394,5 @@
 	mepp = *epp;
 
-	rc = portrng_alloc(repla->portrng, epp->local.port, arg, flags,
+	rc = portrng_alloc(repla->portrng, epp->local.port, arg, aflags_to_pflags(flags),
 	    &mepp.local.port);
 	if (rc != EOK) {
@@ -418,5 +438,5 @@
 	mepp = *epp;
 
-	rc = portrng_alloc(laddr->portrng, epp->local.port, arg, flags,
+	rc = portrng_alloc(laddr->portrng, epp->local.port, arg, aflags_to_pflags(flags),
 	    &mepp.local.port);
 	if (rc != EOK) {
@@ -462,5 +482,5 @@
 	mepp = *epp;
 
-	rc = portrng_alloc(llink->portrng, epp->local.port, arg, flags,
+	rc = portrng_alloc(llink->portrng, epp->local.port, arg, aflags_to_pflags(flags),
 	    &mepp.local.port);
 	if (rc != EOK) {
@@ -494,5 +514,5 @@
 	mepp = *epp;
 
-	rc = portrng_alloc(map->unspec, epp->local.port, arg, flags,
+	rc = portrng_alloc(map->unspec, epp->local.port, arg, aflags_to_pflags(flags),
 	    &mepp.local.port);
 	if (rc != EOK) {
Index: uspace/lib/nettl/src/portrng.c
===================================================================
--- uspace/lib/nettl/src/portrng.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/nettl/src/portrng.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -182,15 +182,19 @@
 void portrng_free_port(portrng_t *pr, uint16_t pnum)
 {
+	log_msg(LOG_DEFAULT, LVL_DEBUG2, "portrng_free_port(%u)", pnum);
 	log_msg(LOG_DEFAULT, LVL_DEBUG2, "portrng_free_port() - begin");
 	list_foreach(pr->used, lprng, portrng_port_t, port) {
+		log_msg(LOG_DEFAULT, LVL_DEBUG2, "portrng_free_port - check port %u", port->pn);
 		if (port->pn == pnum) {
+			log_msg(LOG_DEFAULT, LVL_DEBUG2, "portrng_free_port - OK");
 			list_remove(&port->lprng);
 			free(port);
+			log_msg(LOG_DEFAULT, LVL_DEBUG2, "portrng_free_port() - end");
 			return;
 		}
 	}
 
+	log_msg(LOG_DEFAULT, LVL_DEBUG2, "portrng_free_port - FAIL");
 	assert(false);
-	log_msg(LOG_DEFAULT, LVL_DEBUG2, "portrng_free_port() - end");
 }
 
@@ -209,3 +213,2 @@
  * @}
  */
-
Index: uspace/lib/nic/src/nic_driver.c
===================================================================
--- uspace/lib/nic/src/nic_driver.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/nic/src/nic_driver.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -249,7 +249,7 @@
 	
 	/* Connect to the parent's driver. */
-	parent_sess = ddf_dev_parent_sess_create(dev);
+	parent_sess = ddf_dev_parent_sess_get(dev);
 	if (parent_sess == NULL)
-		return EPARTY;
+		return EIO;
 	
 	return hw_res_get_list_parsed(parent_sess, resources, 0);
Index: uspace/lib/nic/src/nic_rx_control.c
===================================================================
--- uspace/lib/nic/src/nic_rx_control.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/nic/src/nic_rx_control.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -38,5 +38,4 @@
 #include <assert.h>
 #include <stdlib.h>
-#include <stdbool.h>
 #include <errno.h>
 #include <mem.h>
Index: uspace/lib/posix/Makefile
===================================================================
--- uspace/lib/posix/Makefile	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/posix/Makefile	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -55,4 +55,5 @@
 SOURCES = \
 	source/ctype.c \
+	source/dlfcn.c \
 	source/errno.c \
 	source/fcntl.c \
@@ -102,5 +103,5 @@
 	sed 's/.*/posix_& &/' <$(COLLISIONS_LIST) >$@
 
-$(COLLISIONS_LIST):
+$(COLLISIONS_LIST): include/posix/*.h include/posix/*/*.h
 	find ./include/posix -name '*.h' -exec \
 		sed -n -e '/^#/d' -e 's/__POSIX_DEF__/\n&/gp' {} \; | \
Index: uspace/lib/posix/include/posix/dlfcn.h
===================================================================
--- uspace/lib/posix/include/posix/dlfcn.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
+++ uspace/lib/posix/include/posix/dlfcn.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -0,0 +1,56 @@
+/*
+ * Copyright (c) 2017 Vojtech Horky
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libposix
+ * @{
+ */
+
+#ifndef POSIX_DLFCN_H_
+#define POSIX_DLFCN_H_
+
+#ifndef __POSIX_DEF__
+#define __POSIX_DEF__(x) x
+#endif
+
+#define RTLD_LAZY 1
+#define RTLD_NOW 2
+#define RTLD_GLOBAL 32
+#define RTLD_LOCAL 0
+
+
+extern void *__POSIX_DEF__(dlopen)(const char *, int);
+extern void *__POSIX_DEF__(dlsym)(void *, const char *);
+extern int __POSIX_DEF__(dlclose)(void *);
+extern char *__POSIX_DEF__(dlerror)(void);
+
+
+#endif
+
+/**
+ * @}
+ */
Index: uspace/lib/posix/include/posix/stdbool.h
===================================================================
--- uspace/lib/posix/include/posix/stdbool.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
+++ uspace/lib/posix/include/posix/stdbool.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -0,0 +1,46 @@
+/*
+ * Copyright (c) 2017 Vojtech Horky
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libposix
+ * @{
+ */
+/** @file
+ */
+
+#ifndef POSIX_BOOL_H_
+#define POSIX_BOOL_H_
+
+#define bool _Bool
+#define false  0
+#define true   1
+#define __bool_true_false_are_defined 1
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/posix/include/posix/stdint.h
===================================================================
--- uspace/lib/posix/include/posix/stdint.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/posix/include/posix/stdint.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -102,6 +102,4 @@
 #define UINTMAX_MAX UINT64_MAX
 
-#include "libc/sys/types.h"
-
 /*
  * Fast* and least* integer types.
Index: uspace/lib/posix/include/posix/strings.h
===================================================================
--- uspace/lib/posix/include/posix/strings.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/posix/include/posix/strings.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -42,5 +42,5 @@
 
 
-#include <libarch/types.h>
+#include <types/common.h>
 
 /* Search Functions */
Index: uspace/lib/posix/include/posix/sys/time.h
===================================================================
--- uspace/lib/posix/include/posix/sys/time.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
+++ uspace/lib/posix/include/posix/sys/time.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -0,0 +1,45 @@
+/*
+ * Copyright (c) 2017 Vojtech Horky
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libposix
+ * @{
+ */
+
+#ifndef POSIX_SYS_TIME_H_
+#define POSIX_SYS_TIME_H_
+
+#ifndef __POSIX_DEF__
+#define __POSIX_DEF__(x) x
+#endif
+
+#include "libc/sys/time.h"
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/posix/include/posix/sys/types.h
===================================================================
--- uspace/lib/posix/include/posix/sys/types.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/posix/include/posix/sys/types.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -41,6 +41,7 @@
 #endif
 
-#include "libc/sys/types.h"
+#include "libc/offset.h"
 #include "libc/sys/time.h"
+#include "libc/types/common.h"
 
 typedef unsigned int __POSIX_DEF__(ino_t);
Index: uspace/lib/posix/include/posix/unistd.h
===================================================================
--- uspace/lib/posix/include/posix/unistd.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/posix/include/posix/unistd.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -57,4 +57,7 @@
 /* Environment */
 extern char **__POSIX_DEF__(environ);
+
+/* Sleeping */
+extern unsigned int __POSIX_DEF__(sleep)(unsigned int);
 
 /* Login Information */
